; This code is under MikeOS's license.

; @@@ void mikeos_get_int_handler(unsigned int vector, unsigned int *offset, unsigned int *segment);

%include "os_vector.inc"

	section .text
	use16
	global	_mikeos_get_int_handler

_mikeos_get_int_handler:
	push	bp
	mov	bp, sp
	push	di

	mov	bx, os_get_int_handler
	call	bx

	mov	di, [bp + 4]	; get pointer on the stack
	or	di, di		; judge DS/SS
	jz	.1		; NULL pointer, do nothing
	jns	.0
	db	0x36		; SS prefix
.0:
	mov	[di], bx
.1:
	mov	di, [bp + 6]	; get pointer on the stack
	or	di, di		; judge DS/SS
	jz	.3		; NULL pointer, do nothing
	jns	.2
	db	0x36		; SS prefix
.2:
	mov	[di], es
.3:
	pop	di
	pop	bp
	ret
